#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "Manipulacao_Arquivos.h"
#include "Normalizacao.h"
#include "Alocacoes_Memoria.h"

//Funo que aloca um vetor de numeros reais de N Elementos enviado via parametro

float *Alocar_Vetor_real(int Numero_Elementos) {

    float *Vetor; /* ponteiro para o vetor */

    if (Numero_Elementos < 1) { /* verifica parametros recebidos */
        printf("** Erro: Parametro invalido ** Funcao Alocar Vetor\n");
        return (NULL);
    }
    /* aloca o vetor */
    Vetor = new float[Numero_Elementos];
    if (Vetor == NULL) {
        printf("** Erro: Memoria Insuficiente **");
        return (NULL);
    }
    return (Vetor); /* retorna o ponteiro para o vetor */
}

//Funo que aloca um vetor de caracter de N Elementos enviado via parametro

char *Alocar_Vetor_Caracter(int Numero_Elementos) {

    char *Vetor; /* ponteiro para o vetor */

    if (Numero_Elementos < 1) { /* verifica parametros recebidos */
        printf("** Erro: Parametro invalido ** Funcao Alocar Vetor\n");
        return (NULL);
    }
    /* aloca o vetor */
    Vetor = new char[Numero_Elementos];
    if (Vetor == NULL) {
        printf("** Erro: Memoria Insuficiente **");
        return (NULL);
    }
    return (Vetor); /* retorna o ponteiro para o vetor */
}


//Funo que aloca uma string, concatenando com um final enviado via parametro

char *Aloca_String_Final (char String_Original[], char Extensao []) {

    char *Novo_Nome_Arquivo;


    Novo_Nome_Arquivo = Alocar_Vetor_Caracter(strlen(String_Original)+ (strlen(Extensao)+ 5)); //Alocao da nova string
    strcpy(Novo_Nome_Arquivo,""); // inicializao string
    strcpy(Novo_Nome_Arquivo,String_Original); // Cpia da string antiga para a nova
    Novo_Nome_Arquivo[strlen(String_Original) -4] = '\0';
    strcat(Novo_Nome_Arquivo,Extensao); // Concatenar com o novo final
    strcat(Novo_Nome_Arquivo,".txt");
    Novo_Nome_Arquivo[strlen(Novo_Nome_Arquivo)] = '\0';

    return (Novo_Nome_Arquivo);
}

//Funo que aloca um vetor de numeros do tipo double de N Elementos enviado via parametro

double *Alocar_Vetor_double(int Numero_Elementos) {

    double *Vetor; /* ponteiro para o vetor */

    if (Numero_Elementos < 1) { /* verifica parametros recebidos */
        printf("** Erro: Parametro invalido ** Funcao Alocar Vetor\n");
        return (NULL);
    }
    /* aloca o vetor */
    Vetor = new double[Numero_Elementos];
    if (Vetor == NULL) {
        printf("** Erro: Memoria Insuficiente **");
        return (NULL);
    }
    return (Vetor); /* retorna o ponteiro para o vetor */
}

//Funo que aloca um vetor de numeros inteiros de N Elementos enviado via parametro

int *Alocar_Vetor_inteiro(int Numero_Elementos) {

    int *Vetor; /* ponteiro para o vetor */

    if (Numero_Elementos < 1) { /* verifica parametros recebidos */
        printf("** Erro: Parametro invalido ** Funcao Alocar Vetor\n");
        return (NULL);
    }
    /* aloca o vetor */
    Vetor = new int[Numero_Elementos];
    if (Vetor == NULL) {
        printf("** Erro: Memoria Insuficiente **");
        return (NULL);
    }
    return (Vetor); /* retorna o ponteiro para o vetor */
}

//Funo que libera um vetor de valores reais

float *Liberar_Vetor_real(float *Vetor) {

    if (Vetor == NULL) return (NULL);

    delete (Vetor); /* libera o vetor */
    return (NULL); /* retorna o ponteiro */
}



//Funo que libera um vetor de valores caracteres

char *Liberar_Vetor_Caracter(char *Vetor) {

    if (Vetor == NULL) return (NULL);

    delete (Vetor); /* libera o vetor */
    return (NULL); /* retorna o ponteiro */
}

//Funo que libera um vetor de valores do tipo double

double Liberar_Vetor_double(double *Vetor) {

    if (Vetor == NULL) return (NULL);

    delete (Vetor); /* libera o vetor */

    return(NULL);
}

//Funo que libera um vetor de valores do tipo int

int *Liberar_Vetor_real(int *Vetor) {

    if (Vetor == NULL) return (NULL);

    delete (Vetor); /* libera o vetor */
    return (NULL); /* retorna o ponteiro */
}
