#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Arvore.h"
#include "Manipulacao_Arquivos.h"

//Procedimento para desalocar todos os ns de determinada arvore alocada

void Fim_Arvore(No **t) {

     No *q;
    // se t possui sub-rvore esquerda, percorre recursivamente
    if ((*t)->esq)
        Fim_Arvore(&(*t)->esq);

    // se t possui sub-rvore direita, percorre recursivamente
    if ((*t)->dir)
        Fim_Arvore(&(*t)->dir);

    // remove o n folha alcanado
     q = *t;
    (*t) = (*t)->dir;

    delete (q);

}

// Procedimento para imprimir os ns da arvore em pr-Ordem

void Pre_Ordem(No *&ponteiro) {

    if (ponteiro != NULL) {
        printf("Valor -> %d\n", ponteiro -> Valor);
        Pre_Ordem(ponteiro->esq); //percurso recursivo para a esquerda
        Pre_Ordem(ponteiro->dir); //percurso recursivo para a direita

    }
}

//Funo que calcula a altura de cada n de determinada arvore

int Altura(No *&Pont) {
    int Esq, Dir;

    if (Pont == NULL) return 0;
    Esq = Altura(Pont->esq);
    Dir = Altura(Pont->dir);
    if (Esq > Dir) return Esq + 1;
    else return Dir + 1;
}

//Procedimento para balancear a arvore AVL

void AVL(No *&ponteiro) {



    if (ponteiro->esq != NULL) {
        AVL(ponteiro->esq);
    }
    if (ponteiro->dir != NULL) {
        AVL(ponteiro->dir);
    }


    ponteiro->balanco = Altura(ponteiro->dir) - Altura(ponteiro->esq);


    if (ponteiro->balanco == -2) {
        if (ponteiro->esq->balanco == -1) {
            Rotacao_Direita(ponteiro);
        } else Rotacao_Dupla_Direita(ponteiro);
    }
    if (ponteiro->balanco == 2) {
        if (ponteiro->dir->balanco == 1) {
            Rotacao_Esquerda(ponteiro);
        } else Rotacao_Dupla_Esquerda(ponteiro);
    }
}
//Procedimento para a rotao a direita da arvore AVL

void Rotacao_Direita(No *&Pont) {
    No *Ptr;

    Ptr = Pont->esq;
    Pont->esq = Ptr->dir;
    Ptr->dir = Pont;
    Pont->balanco = 0;
    Pont = Ptr;
}

//Procedimento para a rotao dupla direita da rvore AVL

void Rotacao_Dupla_Direita(No *&Pont) {
    No *Ptr, *Pont2;

    Ptr->dir = Pont2->esq;
    Pont2->esq = Ptr;
    Pont->esq = Pont2->dir;
    Pont2->dir = Pont;
    if (Pont2->balanco == -1) {
        Pont->balanco = 1;
    } else {
        (Pont->balanco = 0);
    }
    if (Pont2->balanco == 1) {
        Ptr->balanco = -1;
    } else Ptr->balanco = 0;
    Pont = Pont2;

}
//Procedimento para a rotao a esquerda da arvore AVL

void Rotacao_Esquerda(No *&Pont) {
    No *Ptr;
    Ptr = Pont->dir;
    Pont->dir = Ptr->esq;
    Ptr->esq = Pont;
    Pont->balanco = 0;
    Pont = Ptr;
}

//Procedimento para a rotao dupla esquerda da arvore AVL

void Rotacao_Dupla_Esquerda(No *&Pont) {
    No *Ptr, *v;

    Ptr = Pont->dir;
    v = Ptr->esq;
    Ptr->esq = v->dir;
    v->dir = Ptr;
    Pont->dir = v->esq;
    v->esq = Pont;
    if (v->balanco == 1) Pont->balanco = -1;
    else Pont->balanco = 0;
    if (v->balanco == -1) Ptr->balanco = 1;
    else Ptr->balanco = 0;
    Pont = v;
}

//Procedimento que insere valores em uma arvore AVL

void Insere_Arvore(No **ponteiro, int Valor_A_Ser_Inserido) {


    if ((*ponteiro) == NULL) //criao do Novo n
    {
        (*ponteiro) = new No;

        (*ponteiro)-> Valor = Valor_A_Ser_Inserido;

        (*ponteiro)->dir = (*ponteiro)->esq = 0;

    }

    else {

         if(Verifica_Repetido_Arvore((*ponteiro),Valor_A_Ser_Inserido) == Inexistente){

        if (Valor_A_Ser_Inserido > (*ponteiro)-> Valor) {

            Insere_Arvore(&(*ponteiro)-> dir, Valor_A_Ser_Inserido);

        } else {
            Insere_Arvore(&(*ponteiro)-> esq, Valor_A_Ser_Inserido);

        }

         }
    }

}


void Preencher_Arvore (No *&Arvore, char Endereco_Arquivo []) {

    FILE *Arquivo;
    int Valor_Arquivo;

    Arquivo = Abre_Arquivo_Leitura(Endereco_Arquivo);

    while(!feof(Arquivo)) {
        fscanf(Arquivo,"%d",&Valor_Arquivo);
        if (( Valor_Arquivo <= 32765 ) && (Valor_Arquivo >= -32765 )) {
        Insere_Arvore(&Arvore,Valor_Arquivo);
        }
    }

}


//Funo que faz a verificao de valores repetidos na arvore AVL

Verifica Verifica_Repetido_Arvore(No *Arvore, int Valor) {

     if (Arvore == NULL ) {
       return Inexistente;
    }

    if (Arvore -> Valor == Valor)
       return Existente;


    if (Arvore -> Valor > Valor)
       return Verifica_Repetido_Arvore( Arvore -> esq, Valor);
    else
       return Verifica_Repetido_Arvore( Arvore ->dir, Valor);
}

// Procedimento para imprimir os ns da arvore em pr-Ordem

void Contador_De_Nos(No *&ponteiro, int &Numero_de_Elementos) {

    if (ponteiro != NULL) {
        Numero_de_Elementos ++;
        Contador_De_Nos(ponteiro->esq, Numero_de_Elementos); //percurso recursivo para a esquerda
        Contador_De_Nos(ponteiro->dir, Numero_de_Elementos); //percurso recursivo para a direita

    }
}


// Procedimento para imprimir os ns da arvore em pr-Ordem

void Preencher_Vetor_Valores_Arvore(No *&Arvore, int Vetor_Valores [],int &Indice_Vetor) {

    if (Arvore != NULL) {
        Vetor_Valores[Indice_Vetor] = Arvore -> Valor;
        Indice_Vetor++;
        Preencher_Vetor_Valores_Arvore(Arvore->esq, Vetor_Valores,Indice_Vetor); //percurso recursivo para a esquerda
        Preencher_Vetor_Valores_Arvore(Arvore->dir, Vetor_Valores,Indice_Vetor); //percurso recursivo para a direita

    }
}
